#ifndef _GSMANIFEST_H_
#define _GSMANIFEST_H_
#include <map>
using namespace std;

#include "File.h"
#include "FilePath.h"
#include "stringArray.h"

typedef map<FilePath, stringArray, less<FilePath> > pathStringArrayMap;

class gsManifest
{	private:
	protected:
		strArrayMap					manifests;
    pathStringArrayMap	selected;
  public:
  	gsManifest(FilePath &path);
    bool getManifest(FilePath &path);
    bool getManifestLine(char *line, string &macro);
    void expandGroupInstance(string parent, string child);
    void expandGroup(string &group);
    void expandGroups();
    bool isGroup(string &name);
    void expandMacro(string macroName, string value);
    void clearSelection();
    bool copy(FilePath *source);
    void selectGroup(string &groupName, FilePath &destination);
    FileVector *selection(stringArray &array);
    FileVector *selection(FilePath &destination);
    bool selectCheckSpace();
};
#endif;